package com.scbfkj.uni.library;

import jakarta.servlet.http.HttpServletRequest;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import java.util.Map;
import java.util.Objects;

import static org.springframework.web.context.request.RequestAttributes.SCOPE_REQUEST;
import static org.springframework.web.context.request.RequestAttributes.SCOPE_SESSION;

public class RequestUtil {

    public static String getIpAddr() {
//        请求
        ServletRequestAttributes requestAttributes = (ServletRequestAttributes) RequestContextHolder.currentRequestAttributes();
//
        HttpServletRequest request = requestAttributes.getRequest();
        String ip = request.getHeader("x-forwarded-for");
        if (ip == null || ip.length() == 0 || "unknown".equalsIgnoreCase(ip)) {
            ip = request.getHeader("Proxy-Client-IP");
        }
        if (ip == null || ip.length() == 0 || "unknown".equalsIgnoreCase(ip)) {
            ip = request.getHeader("WL-Proxy-Client-IP");
        }
        if (ip == null || ip.length() == 0 || "unknown".equalsIgnoreCase(ip)) {
            ip = request.getRemoteAddr();
        }
        return ip;
    }

    public static String getAppToken() {
//        请求
        ServletRequestAttributes requestAttributes = (ServletRequestAttributes) RequestContextHolder.currentRequestAttributes();
//
        Object appToken = requestAttributes.getAttribute("token", SCOPE_REQUEST);
        return Objects.nonNull(appToken) ? appToken.toString() : null;

    }

    public static String getUserToken() {
//        请求
        ServletRequestAttributes requestAttributes = (ServletRequestAttributes) RequestContextHolder.currentRequestAttributes();
//
        Object appToken = requestAttributes.getAttribute("usertoken", SCOPE_REQUEST);
        return Objects.nonNull(appToken) ? appToken.toString() : null;

    }
    public static String getAppId() {
//        请求
        ServletRequestAttributes requestAttributes = (ServletRequestAttributes) RequestContextHolder.currentRequestAttributes();
//
        Object appid = requestAttributes.getAttribute("appid", SCOPE_SESSION);
        return Objects.nonNull(appid) ? appid.toString() : null;

    }
    public static Map<String,Object> getApplication() {
//        请求
        ServletRequestAttributes requestAttributes = (ServletRequestAttributes) RequestContextHolder.currentRequestAttributes();
//
        Object application = requestAttributes.getAttribute("application", SCOPE_SESSION);
        return Objects.nonNull(application) ? (Map<String, Object>) application : null;

    }
    public static String getUserId() {
//        请求
        ServletRequestAttributes requestAttributes = (ServletRequestAttributes) RequestContextHolder.currentRequestAttributes();
//
        Object appid = requestAttributes.getAttribute("userid", SCOPE_SESSION);
        return Objects.nonNull(appid) ? appid.toString() : null;

    }
    public static Map<String,Object> getUserInfo() {
//        请求
        ServletRequestAttributes requestAttributes = (ServletRequestAttributes) RequestContextHolder.currentRequestAttributes();
//
        Object userInfo = requestAttributes.getAttribute("userinfo", SCOPE_SESSION);
        return Objects.nonNull(userInfo) ? (Map<String, Object>) userInfo : null;
    }

    public static String getSessionId() {
        return RequestContextHolder.currentRequestAttributes().getSessionId();

    }

}
